library keylib;


uses
  SysUtils,
  Classes,
  Windows,
  Messages;

type
  PHookRec = ^THookRec;
  THookRec = record
    AppHnd: Integer;
  end;

var
  Hooked: Boolean;
  hKeyHook, hMemFile, hApp: HWND;
  PHookRec1: PHookRec;

const
  WM_COMMIPC = WM_USER + 1611 ;
  MapName : PChar = 'KeylibGlobalMap' ;

function KeyHookFunc(Code, VirtualKey, KeyStroke: Integer): LRESULT; stdcall;
var
  KeyState1: TKeyBoardState;
  AryChar: array[0..1] of Char;
  Count: Integer;
begin
  Result := 0;
  if Code = HC_NOREMOVE then Exit;
  Result := CallNextHookEx(hKeyHook, Code, VirtualKey, KeyStroke);
  if Code < 0 then Exit; 
  if Code = HC_ACTION then
  begin
    if ((KeyStroke and (1 shl 30)) <> 0) then
    begin
      hMemFile  := OpenFileMapping(FILE_MAP_WRITE, False, MapName);
      PHookRec1 := MapViewOfFile(hMemFile, FILE_MAP_WRITE, 0, 0, 0);
      if PHookRec1 <> nil then hApp  := PHookRec1.AppHnd;
      if ((KeyStroke and (1 shl 30)) <> 0) then
      begin
        GetKeyboardState(KeyState1);
        Count := ToAscii(VirtualKey, KeyStroke, KeyState1, AryChar, 0);
        if Count = 1 then PostMessage(hApp, WM_COMMIPC, Ord(AryChar[0]), 0);
      end;
    end ;
  end;
end;

function StartHook(AppHandle: HWND): Byte; export;
begin
  Result := 0;
  if Hooked then
  begin
    Result := 1;
  end
  else
  begin
    hKeyHook := SetWindowsHookEx(WH_KEYBOARD, KeyHookFunc, hInstance, 0);
    if hKeyHook > 0 then
    begin
      hMemFile := CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE, 0, SizeOf(THookRec), MapName);
      PHookRec1 := MapViewOfFile(hMemFile, FILE_MAP_WRITE, 0, 0, 0);
      hApp := AppHandle;
      PHookRec1.AppHnd := AppHandle;
      Hooked := True;
    end
    else Result := 2;
  end;
end;

function StopHook: Boolean; export;
begin
  if PHookRec1 <> nil then
  begin
    UnmapViewOfFile(PHookRec1);
    CloseHandle(hMemFile);
    PHookRec1 := nil;
  end;
  if Hooked then Result := UnhookWindowsHookEx(hKeyHook) else Result := True;
  Hooked := False;
end;

procedure EntryProc(dwReason: DWORD);
begin
  if (dwReason = Dll_Process_Detach) then
  begin
    if PHookRec1 <> nil then
    begin
      UnmapViewOfFile(PHookRec1);
      CloseHandle(hMemFile);
    end;
    UnhookWindowsHookEx(hKeyHook);
  end;
end;

exports
  StartHook,
  StopHook;

begin
  PHookRec1 := nil;
  Hooked := False;
  hKeyHook := 0;
  DLLProc := @EntryProc;
  EntryProc(Dll_Process_Attach);
end.
